onedoc/documents/forms.py
from flask_wtf import FlaskForm
from wtforms import StringField, SubmitField
from wtforms.validators import DataRequired, ValidationError
from onedoc.models import Document

class DocForm(FlaskForm):
    title = StringField('Tytuł', validators=[DataRequired()])
    submit = SubmitField('Utwórz dokument')


class UpdateDocForm(FlaskForm):
    title = StringField('Tytuł', validators=[DataRequired()])
    submit = SubmitField('Zapisz')

    def validate_title(self, title):
        title = Document.query.filter_by(title=title.data).first()
        if title:
            raise ValidationError('Ta nazwa dokumentu jest zajęta, proszę wybrać inną.')

onedoc/documents/routes.py
from flask import (render_template, url_for, flash,
                   redirect, Blueprint, abort, request)
from flask_login import current_user, login_required
from onedoc import db
from onedoc.models import Document, Branch, Section
from onedoc.documents.forms import DocForm, UpdateDocForm
from markupsafe import Markup
import markdown

documents = Blueprint('documents', __name__)


@documents.route("/create_document", methods=['GET', 'POST'])
@login_required
def new():
    if current_user.role != 'admin':
        return redirect(url_for('main.home'))
    form = DocForm()
    if form.validate_on_submit():
        document = Document(title=form.title.data)
        db.session.add(document)
        db.session.commit()
        flash('Dokument został utworzony!', 'success')
        return redirect(url_for('main.home'))
    return render_template('create_document.html', title='New Document',
                           form=form, legend='Nowy dokument')


@documents.route("/documents/<int:id_document>")
def show(id_document):
    document = Document.query.get_or_404(id_document)
    user_sections = []


    if current_user.is_anonymous:
        return redirect(url_for('main.home'))

    sec_def = list(filter(lambda sec: sec.id_branch is None, document.sections))
    for s in sec_def:
        try:
            # Check if there is a dedicated section for user branch
            sec_b = next(filter(lambda sec: sec.id_branch == current_user.id_branch and sec.id_section_default == s.id,
                                document.sections))
            user_sections.append(sec_b)
        except StopIteration:
            user_sections.append(s)
    
    l = []

    for i in range(len(user_sections)):
        l.append(i+1)
    
    last_btn = len(l) + 1

    markdown_content = []

    for user_section in user_sections:
        body = Markup(markdown.markdown(user_section.content, extensions=['fenced_code', 'footnotes', 'toc']))
        markdown_content.append(body)

    return render_template('document.html', document=document, last_btn=last_btn, sections_l = zip(user_sections, l, markdown_content))

 
@documents.route("/documents/<int:id_document>/update", methods=['GET', 'POST'])
@login_required
def update(id_document):
    document = Document.query.get_or_404(id_document)
    if current_user.role != 'admin':
        abort(403)
    form = UpdateDocForm()
    if form.validate_on_submit():
        document.title = form.title.data
        db.session.commit()
        flash('Dokument został zaktualizowany!', 'success')
        return redirect(url_for('main.home'))
    elif request.method == 'GET':
        form.title.data = document.title
    return render_template('create_document.html', title='Update Document',
                           form=form, legend='Edycja dokumentu')


@documents.route("/documents/<int:id_document>/delete", methods=['GET', 'POST'])
@login_required
def delete(id_document):
    document = Document.query.get_or_404(id_document)
    if current_user.role != 'admin':
        abort(403)
    db.session.delete(document)
    db.session.commit()
    flash('Dokument został usunięty!', 'success')
    return redirect(url_for('main.home'))

onedoc/sections/routes.py
from flask import (render_template, url_for, flash,
                   redirect, request, abort, Blueprint)
from flask_login import current_user, login_required
from onedoc import db
from onedoc.models import Section, Branch, Document
from onedoc.sections.forms import SectionForm, UpdateSectionForm, ConfigForm
from markupsafe import Markup
import markdown


sections = Blueprint('sections', __name__)


@sections.route("/section/new/<int:doc_id>/<int:btn_num>", methods=['GET', 'POST'])
@login_required
def new(doc_id, btn_num):
    document = Document.query.get_or_404(doc_id)

    if current_user.role != 'admin' and current_user.role != 'moderator':
         return redirect(url_for('main.home'))
    form = SectionForm()

    #sorting of sections
    
    current_doc_sec = list(filter(lambda sec: sec.id_document == doc_id, document.sections))
    
    if current_doc_sec:
        next_sec = list(filter(lambda sec: sec.document_sort >= btn_num, document.sections))
        
        for s in next_sec:
            s.document_sort = s.document_sort+1
    else:
        btn_num = 1
        

    if form.validate_on_submit():
        section = Section(title=form.title.data, id_document=doc_id, content=form.content.data, author=current_user, document_sort=btn_num)
        db.session.add(section)
        db.session.commit()
        flash('Sekcja została utworzona!', 'success')
        return redirect(url_for('documents.show', id_document = section.id_document))
    return render_template('create_section.html', title='New Section',
                           form=form, legend='Nowa Sekcja')


@sections.route("/section/<int:section_id>")
def show(section_id):
    branches = Branch.query.all()
    section = Section.query.get_or_404(section_id)
    body = Markup(markdown.markdown(section.content, extensions=['fenced_code', 'footnotes', 'toc']))
    return render_template('section.html', title=section.title, branches=branches, section=section, body=body)


@sections.route("/branch_section/<int:id_branch>")
def show_branch(id_branch):
    sections = Section.query.all()
    section = Section.query.get_or_404(id_branch)
    return render_template('branch_section.html', sections=sections, section=section, id_branch=id_branch)


@sections.route("/section/<int:section_id>/update", methods=['GET', 'POST'])
@login_required
def update(section_id):
    section = Section.query.get_or_404(section_id)
    documents = Document.query.all()
    if current_user.role != 'admin' and current_user.role != 'moderator':
        abort(403)
    form = UpdateSectionForm()
    if form.validate_on_submit():
        section.title = form.title.data
        section.content = form.content.data
        db.session.commit()
        flash('Twoja sekcja została zaktualizowana!', 'success')
        return redirect(url_for('documents.show', id_document = section.id_document))
    elif request.method == 'GET':
        form.title.data = section.title
        form.content.data = section.content
    return render_template('update_section.html', title='Update Section',
                           form=form, legend='Edycja sekcji', documents=documents, section=section)


@sections.route("/section/<int:section_id>/delete", methods=['POST'])
@login_required
def delete(section_id):
    if current_user.role != 'admin' and current_user.role != 'moderator':
        abort(403)
    
    section = Section.query.get_or_404(section_id)
    document = Document.query.get_or_404(section.id_document)
    
    sec = list(filter(lambda sec: sec.document_sort > section.document_sort, document.sections))
    
    if sec:
        for s in sec:
            s.document_sort = s.document_sort-1

    db.session.delete(section)
    db.session.commit()
    flash('Twoja sekcja została usunięta!', 'success')
    return redirect(url_for('main.home'))

@sections.route("/section/<int:section_id>/config", methods=['GET', 'POST'])
@login_required
def add_for_branch(section_id):
    section = Section.query.get_or_404(section_id)
    branches = Branch.query.all()
    if current_user.role != 'admin':
        abort(403)
    form = ConfigForm()
    if form.validate_on_submit():
        conf_section = Section(title=form.title.data, id_document=section.id_document, content=form.content.data, author=current_user, id_section_default = section_id, id_branch=form.branch.data, document_sort=section.document_sort)
        db.session.add(conf_section)
        db.session.commit()
        flash('Wydzielono gałąź', 'success')
        return redirect(url_for('sections.show', section_id=section.id))
    elif request.method == 'GET':
        form.title.data = section.title
        form.content.data = section.content
    return render_template('add_for_branch.html', title='Add For Branch',
                           form=form, legend='Wydzielanie dla gałęzi',
                           branches=branches)

@sections.route("/section/<int:doc_id>/<int:doc_sort>/up", methods=['GET', 'POST'])
@login_required
def up(doc_id, doc_sort):
    document = Document.query.get_or_404(doc_id)
    sec = next(filter(lambda sec: sec.document_sort==doc_sort and sec.id_document == doc_id, document.sections))
    sec_upper = next(filter(lambda sec: sec.document_sort==doc_sort-1 and sec.id_document == doc_id, document.sections))

    sec.document_sort = sec.document_sort-1
    sec_upper.document_sort = sec.document_sort+1

    db.session.commit()

    return redirect(url_for('documents.show', id_document = doc_id))


@sections.route("/section/<int:doc_id>/<int:doc_sort>/down", methods=['GET', 'POST'])
@login_required
def down(doc_id, doc_sort):
    document = Document.query.get_or_404(doc_id)
    sec = next(filter(lambda sec: sec.document_sort==doc_sort and sec.id_document == doc_id, document.sections))
    sec_lower = next(filter(lambda sec: sec.document_sort==doc_sort+1 and sec.id_document == doc_id, document.sections))

    sec.document_sort = sec.document_sort+1
    sec_lower.document_sort = sec.document_sort-1

    db.session.commit()

    return redirect(url_for('documents.show', id_document = doc_id))

onedoc/users/routes.py
from flask import render_template, url_for, flash, redirect, request, Blueprint, abort
from flask_login import login_user, current_user, logout_user, login_required
from onedoc import db, bcrypt
from onedoc.models import User, Section, Branch
from onedoc.users.forms import (RegistrationForm, LoginForm, UpdateAccountForm,
                                   RequestResetForm, ResetPasswordForm, UpdateAccountFormUser)
from onedoc.users.utils import save_picture, send_reset_email

users = Blueprint('users', __name__)


@users.route("/register", methods=['GET', 'POST'])
@login_required
def register():
    form = RegistrationForm()
    if form.validate_on_submit():
        hashed_password = bcrypt.generate_password_hash(form.password.data).decode('utf-8')
        user = User(username=form.username.data, email=form.email.data, password=hashed_password, role=form.role.data, id_branch=form.branch.data)
        db.session.add(user)
        db.session.commit()
        flash('Konto założone pomyślnie!', 'success')
        return redirect(url_for('users.login'))
    return render_template('register.html', title='Register', form=form)


@users.route("/login", methods=['GET', 'POST'])
def login():
    if current_user.is_authenticated:
        return redirect(url_for('main.home'))
    form = LoginForm()
    if form.validate_on_submit():
        user = User.query.filter_by(email=form.email.data).first()
        if user and bcrypt.check_password_hash(user.password, form.password.data):
            login_user(user, remember=form.remember.data)
            next_page = request.args.get('next')
            return redirect(next_page) if next_page else redirect(url_for('main.home'))
        else:
            flash('Logowanie nieudane, sprawdź wprowadzone dane', 'danger')
    return render_template('login.html', title='Login', form=form)


@users.route("/logout")
def logout():
    logout_user()
    return redirect(url_for('main.home'))
    

@users.route("/account", methods=['GET', 'POST'])
@login_required
def account():
    branches = Branch.query.all()
    form = UpdateAccountForm()
    if form.validate_on_submit():
        if form.picture.data:
            picture_file = save_picture(form.picture.data)
            current_user.image_file = picture_file
        current_user.username = form.username.data
        current_user.email = form.email.data
        db.session.commit()
        flash('Konto zostało zaktualizowane', 'success')
        return redirect(url_for('users.account'))
    elif request.method == 'GET':
        form.username.data = current_user.username
        form.email.data = current_user.email
    image_file = url_for('static', filename='profile_pics/' + current_user.image_file)
    return render_template('account.html', title='Account',
                           image_file=image_file, form=form, branches=branches)


@users.route("/user/<string:username>")
def sections(username):
    page = request.args.get('page', 1, type=int)
    user = User.query.filter_by(username=username).first_or_404()
    sections = Section.query.filter_by(author=user)\
        .order_by(Section.date_posted.desc())\
        .paginate(page=page, per_page=5)
    return render_template('user_sections.html', sections=sections, user=user)

@users.route("/res_pass", methods=['GET', 'POST'])
@login_required
def res_pass():
    form = ResetPasswordForm()
    if form.validate_on_submit():
        current_user.password = form.password.data
        hashed_password = bcrypt.generate_password_hash(form.password.data).decode('utf-8')
        current_user.password = hashed_password
        db.session.commit()
        flash('Hasło zostało zmienione', 'success')
        return redirect(url_for('users.account'))
    return render_template('res_pass.html', title='Account', form=form)

@users.route("/reset_password", methods=['GET', 'POST'])
def reset_request():
    if current_user.is_authenticated:
        return redirect(url_for('main.home'))
    form = RequestResetForm()
    if form.validate_on_submit():
        user = User.query.filter_by(email=form.email.data).first()
        send_reset_email(user)
        flash('E-mail wraz z instrukcjami do resetu hasła został pomyślnie wysłany na podany adres.', 'info')
        return redirect(url_for('users.login'))
    return render_template('reset_request.html', title='Reset Password', form=form)


@users.route("/reset_password/<token>", methods=['GET', 'POST'])
def reset_token(token):
    if current_user.is_authenticated:
        return redirect(url_for('main.home'))
    user = User.verify_reset_token(token)
    if user is None:
        flash('Nieprawidłowy lub wygasły token. Spróbuj jeszcze raz.', 'warning')
        return redirect(url_for('users.reset_request'))
    form = ResetPasswordForm()
    if form.validate_on_submit():
        hashed_password = bcrypt.generate_password_hash(form.password.data).decode('utf-8')
        user.password = hashed_password
        db.session.commit()
        flash('Twoje hasło zostało pomyślnie zmienione!', 'success')
        return redirect(url_for('users.login'))
    return render_template('reset_token.html', title='Reset Password', form=form)

@users.route("/users_list")
@login_required
def list():
    users = User.query.all()
    if current_user.role != "admin":
        return redirect(url_for('main.home'))
    else:
        return render_template('users_list.html', users=users)

@users.route("/admin_account/<int:id_user>", methods=['GET', 'POST'])
@login_required
def admin_account(id_user):
    userbranch = request.form.get('selectbranch')
    print(userbranch)
    branches = Branch.query.all()
    if current_user.role != 'admin':
        return redirect(url_for('main.home'))
    user = User.query.get_or_404(id_user)
    form = UpdateAccountFormUser()
    if form.validate_on_submit():
        if form.picture.data:
            picture_file = save_picture(form.picture.data)
            user.image_file = picture_file
        user.username = form.username.data
        user.email = form.email.data
        user.id_branch = userbranch
        db.session.commit()
        flash('Konto zostało zaktualizowane', 'success')
        return redirect(url_for('users.admin_account', id_user=user.id))
    elif request.method == 'GET':
        form.username.data = user.username
        form.email.data = user.email
    image_file = url_for('static', filename='profile_pics/' + user.image_file)
    return render_template('admin_account.html', title='Account',
                           image_file=image_file, form=form, user=user, branches=branches)

# Delete of the user in the List screen
@users.route("/admin_account/<int:id_user>/delete", methods=['POST'])
@login_required
def delete(id_user):
    user = User.query.get_or_404(id_user)
    if current_user.role != 'admin':
        abort(403)
    db.session.delete(user)
    db.session.commit()
    flash('Użytkownik został usunięty!', 'warning')
    return redirect(url_for('users.list'))

onedoc/templates/branch_section.html
{% extends "layout.html" %}
{% block content %}
<article class="media content-section">
  <div class="media-body">
    <div class="article-metadata">
      {% if current_user.role == 'admin' %}
      <div>
        <a class="btn btn-secondary btn-sm m-1" href="javascript:history.back()">Powrót</a>
        
      {% endif %}
      
      {% for section in sections %}
        {% if section.id_branch == id_branch %}
          <h3><a class="article-title" href="{{ url_for('sections.show', section_id=section.id) }}">{{ section.title }}</a></h3>
          <p class="article-content">{{ section.content }}</p>
        {% endif %}
        
      {% endfor %}
    </div>
  </div>
</article>

<script>
  const content_text = document.getElementsByClassName("article-content");

    for (let i = 0; i <= content_text.length; i++) {
      content_text[i].innerHTML = marked(content_text[i].innerHTML);
    }
</script>
{% endblock content %}

onedoc/templates/document.html
{% extends "layout.html" %}
{% block content %}
<article class="media content-section">
  <h2 class="document-title">{{ document.title }}</h2>
  
  <div class="media-body" style="margin-top: 70px;">
    {% if current_user.role == 'admin' %}
        <div class="center">
            <a class="btn btn-secondary btn-sm m-1" href="{{ url_for('documents.update', id_document=document.id) }}" id="btn-check">Edytuj dokument</a>
            <button type="button" class="btn btn-danger btn-sm m-1" data-toggle="modal"
            data-target="#deleteModal">Usuń dokument</button>
        </div>
  {% endif %}
    {% if sections_l: %}
      {% for user_sections, l, markdown_content in sections_l %}
      <div class="article-content2">
        <a href="{{ url_for('sections.new', doc_id=user_sections.id_document, btn_num=l) }}">
        <button type="button" class="addbtn">
          +
        </button>
      </a>
      </div>
      {% if user_sections.document_sort == 1 %}
      {% else %}
      <div class="article-content2">
      <a href="{{ url_for('sections.up', doc_sort=user_sections.document_sort, doc_id=user_sections.id_document) }}">
        <button class="up" value="add" name="add">↑</button>
      </a>
    </div>
      {% endif %}
      {% if user_sections.document_sort == last_btn-1 %}
      {% else %}
      <div class="article-content2">
      <a href="{{ url_for('sections.down', doc_sort=user_sections.document_sort, doc_id=user_sections.id_document) }}">
        <button class="down" value="reduce" name="reduce">
          ↓
        </button>
      </a>
    </div> 
      {% endif %}
      {% if user_sections.content == "" %}
      <div class="section">
      <h3><a class="article-title" href="{{ url_for('sections.show', section_id=user_sections.id) }}">[ sekcja dedykowana ]</a></h3>
      <div class="article-content"><a class="section_link" href="{{ url_for('sections.show', section_id=user_sections.id) }}">{{ markdown_content }}</a></div>
    </div>
      {% elif user_sections.title == "" %}
      <div class="section">
      <div class="article-content"><a class="section_link" href="{{ url_for('sections.show', section_id=user_sections.id) }}">{{ markdown_content }}</a></div>
    </div>
      {% else %}
      <div class="section">
        <h3><a class="article-title" href="{{ url_for('sections.show', section_id=user_sections.id) }}">{{ user_sections.title }}</a></h3>
          <div class="article-content"><a class="section_link" href="{{ url_for('sections.show', section_id=user_sections.id) }}">{{ markdown_content }}</a></div>
        </div>
      {% endif %}
      {% endfor %}
      <div class="article-content2">
        <a href="{{ url_for('sections.new', doc_id=document.id, btn_num=last_btn) }}">
        <button type="button" class="addbtn">
          +
        </button>
      </a>
      </div>
    {% else %}
    <div class="article-content2">
      <a href="{{ url_for('sections.new', doc_id=document.id, btn_num=1) }}">
      <button type="button" class="addbtn">
      </button>
    </a>
    </div>
    {% endif %}
  </div>
</article>
<div class="modal fade" id="deleteModal" tabindex="-1" role="dialog" aria-labelledby="deleteModalLabel"
  aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="deleteModalLabel">Czy na pewno chcesz usunąć dokument?</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Zamknij</button>
        <form action="{{ url_for('documents.delete', id_document=document.id) }}" method="POST">
          <input class="btn btn-danger" type="submit" value="Usuń">
        </form>
      </div>
    </div>
  </div>
</div>

{% endblock content %}

onedoc/templates/layout.html
<!DOCTYPE html>
<html>
<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">

    <link rel="stylesheet" type="text/css" href="{{ url_for('static', filename='main.css') }}">
    
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/simplemde/latest/simplemde.min.css">
    <!-- JS Links -->
    <script src="https://cdn.jsdelivr.net/simplemde/latest/simplemde.min.js"></script>
    

    {% if title %}
        <title>KLL - {{ title }}</title>
    {% else %}
        <title>OneDoc</title>
    {% endif %}
</head>
<body>
    <header class="site-header">
      <nav class="navbar navbar-expand-md navbar-dark bg-steel fixed-top">
        <div class="container">
          <a class="navbar-brand mr-4" href="/">OneDoc</a>

          <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarToggle" aria-controls="navbarToggle" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
          </button>
          <div class="collapse navbar-collapse" id="navbarToggle">
            <div class="navbar-nav mr-auto">
            </div>
            <!-- Navbar Right Side -->
            <div class="navbar-nav">
              {% if current_user.is_authenticated %}
              <a class="nav-item nav-link" href="{{ url_for('users.account') }}">Konto</a>
              <a class="nav-item nav-link" href="{{ url_for('users.logout') }}">Wyloguj</a>
                {% if current_user.role == 'admin' %}
                <a class="nav-item nav-link" href="{{ url_for('users.list') }}">Lista użytkowników</a>
                <a class="nav-item nav-link" href="{{ url_for('branches.list') }}">Lista gałęzi</a>
                <a class="nav-item nav-link" href="{{ url_for('users.register') }}">Rejestracja</a>
                <a class="nav-item nav-link" href="{{ url_for('documents.new') }}">Dodaj dokument</a>
                {% elif current_user.role == 'moderator' %}
                <a class="nav-item nav-link" href="{{ url_for('sections.new') }}">Dodaj sekcje</a>
                {% elif current_user.role == 'subscriber' %}

                {% endif %}
              {% else %}
              <a class="nav-item nav-link" href="{{ url_for('users.login') }}">Logowanie</a>
              {% endif %}
            </div>
          </div>
        </div>
      </nav>
    </header>
    <main class="w-100">
      <div class="col-sm-12">
      <div class="row">
        <div class="col-md-3">
          {% if current_user.is_anonymous == False %}
          <div class="content-section">
            <h3>OneDoc</h3>
            <p class='text-muted' id="muted">OneDoc jest narzędziem służącym do efektywnego tworzenia dokumentacji dla różnych wdrożeń i konfiguracji tego samego produktu u klienta.
              <ul class="list-group">
                <li class="list-group-item list-group-item-light"><input type="text" placeholder="Wyszukiwanie" id="search_input"></li>
              </ul>
            </p>
          </div>
          {% endif %}
          {% if current_user.is_anonymous == False %}
          <div class="content-layout">
          <div class="content-section">
            <h3 style="text-align: left;"><a href="/">MENU</a></h3>
            {% for document in documents %}
            <ul class="navbar-nav ml-auto">
              <h3 style="margin-top: 10px;"><li class="nav-item"><a href="{{ url_for('documents.show', id_document=document.id) }}">{{ document.title }}</a></li></h3>
              {% for section in sections %}
                {% if current_user.role == 'admin' %}
                  {% if document.id == section.id_document and section.id_branch == None %}
                    <div class="nav flex-column nav-pills" id="v-pills-tab" role="tablist" aria-orientation="vertical">
                      <a class="nav-link" id="v-pills-home-tab"  href="{{ url_for('sections.section', section_id=section.id) }}" role="tab" aria-controls="v-pills-home" aria-selected="true">{{ section.title }}</a>
                    </div>
                  {% endif %}
                  {% elif current_user.id_branch == section.id_branch or section.id_branch == None %}
                    {% if document.id == section.id_document %}
                      <div class="nav flex-column nav-pills" id="v-pills-tab" role="tablist" aria-orientation="vertical">
                        <a class="nav-link" id="v-pills-home-tab"  href="{{ url_for('sections.section', section_id=section.id) }}" role="tab" aria-controls="v-pills-home" aria-selected="true">{{ section.title }}</a>
                      </div>
                    {% endif %}
                  {% endif %}
              {% endfor %}
            </ul>
            {% endfor %}
          {% endif %}
          </div>
        </div>
        </div>
        <div class="col-md-9">
          {% with messages = get_flashed_messages(with_categories=true) %}
            {% if messages %}
              {% for category, message in messages %}
                <div class="alert alert-{{ category }}">
                  {{ message }}
                </div>
              {% endfor %}
            {% endif %}
          {% endwith %}
          {% block content %}{% endblock %}
        </div>
      </div>
    </div>
    </main>

    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
    <script src="../static/script.js"></script>

</body>
</html>

onedoc/templates/section.html
{% extends "layout.html" %}
{% block content %}
<article class="media content-section">
  <div class="media-body">
    <div class="article-metadata">
      {% if current_user.role == 'admin' %}
      <div>
        <a class="btn btn-secondary btn-sm m-1" href="{{ url_for('sections.update', section_id=section.id) }}">Edytuj</a>
        <a class="btn btn-secondary btn-sm m-1" href="{{ url_for('sections.add_for_branch', section_id=section.id) }}">Wydziel dla gałęzi</a>
        <button type="button" class="btn btn-danger btn-sm m-1" data-toggle="modal" data-target="#deleteModal">Usuń</button>
        {% for branch in branches %}
          {% if branch.id == section.id_branch %}
           <strong>Gałąź sekcji: </strong>  <a class="btn btn-secondary btn-sm m-1" id="btn" href="{{ url_for('sections.show_branch', id_branch=branch.id) }}">{{ branch.name }}</a>
          {% endif %}
        {% endfor %}
      </div>
      {% elif section.author == current_user %}
      <div>
        <a class="btn btn-secondary btn-sm m-1" href="{{ url_for('sections.update', section_id=section.id) }}">Edytuj</a>
        <button type="button" class="btn btn-danger btn-sm m-1" data-toggle="modal"
          data-target="#deleteModal">Usuń</button>
      </div>
      {% endif %}
    </div>
    <h2 class="article-title">{{ section.title }}</h2>
    <div class="article-content">{{ body }}</div>
  </div>
</article>
<div class="modal fade" id="deleteModal" tabindex="-1" role="dialog" aria-labelledby="deleteModalLabel"
  aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="deleteModalLabel">Czy na pewno chcesz usunąć?</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Zamknij</button>
        <form action="{{ url_for('sections.delete', section_id=section.id) }}" method="POST">
          <input class="btn btn-danger" type="submit" value="Usuń">
        </form>
      </div>
    </div>
  </div>
</div>
{% endblock content %}